<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.jsmat.variable;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataOutput;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.IOException;<a name="line.37"></a>
<FONT color="green">038</FONT>    <a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.jsmat.common.MatClass;<a name="line.39"></a>
<FONT color="green">040</FONT>    <a name="line.40"></a>
<FONT color="green">041</FONT>    /**<a name="line.41"></a>
<FONT color="green">042</FONT>     * &lt;tt&gt;MatAllocated&lt;/tt&gt; is a variable which allocates space and data. Such <a name="line.42"></a>
<FONT color="green">043</FONT>     * variables are the most simple to use, e.g. to allocate <a name="line.43"></a>
<FONT color="green">044</FONT>     * {@link MatMatrix matrix variables} by passing the data they represent. <a name="line.44"></a>
<FONT color="green">045</FONT>     * &lt;p&gt;<a name="line.45"></a>
<FONT color="green">046</FONT>     * For large matrices, {@link MatReserved} variables might be preferable since<a name="line.46"></a>
<FONT color="green">047</FONT>     * they only reserve space, but do not allocate it.<a name="line.47"></a>
<FONT color="green">048</FONT>     */<a name="line.48"></a>
<FONT color="green">049</FONT>    abstract public class MatAllocated extends MatVariable {<a name="line.49"></a>
<FONT color="green">050</FONT>            <a name="line.50"></a>
<FONT color="green">051</FONT>            /**<a name="line.51"></a>
<FONT color="green">052</FONT>             * Constructor for subclasses with matrix class and dimensions<a name="line.52"></a>
<FONT color="green">053</FONT>             * @param matClass      the matrix class constant<a name="line.53"></a>
<FONT color="green">054</FONT>             * @param dims          the matrix dimensions<a name="line.54"></a>
<FONT color="green">055</FONT>             */<a name="line.55"></a>
<FONT color="green">056</FONT>            public MatAllocated(MatClass matClass, int[] dims) {<a name="line.56"></a>
<FONT color="green">057</FONT>                    super(matClass, dims);<a name="line.57"></a>
<FONT color="green">058</FONT>            }<a name="line.58"></a>
<FONT color="green">059</FONT>            <a name="line.59"></a>
<FONT color="green">060</FONT>        /**<a name="line.60"></a>
<FONT color="green">061</FONT>         * Write the raw data to the given output, excluding type, size, name etc.<a name="line.61"></a>
<FONT color="green">062</FONT>         * This method is implemented by the type specific subclasses. <a name="line.62"></a>
<FONT color="green">063</FONT>         * <a name="line.63"></a>
<FONT color="green">064</FONT>         * @param out                       the data output to write to<a name="line.64"></a>
<FONT color="green">065</FONT>         * @throws IOException      if any io exception occurs<a name="line.65"></a>
<FONT color="green">066</FONT>         */<a name="line.66"></a>
<FONT color="green">067</FONT>        protected abstract void writeRawData(DataOutput out) throws IOException;<a name="line.67"></a>
<FONT color="green">068</FONT>    <a name="line.68"></a>
<FONT color="green">069</FONT>        /**<a name="line.69"></a>
<FONT color="green">070</FONT>         * Writes the data to the given data output. At the end of this method,<a name="line.70"></a>
<FONT color="green">071</FONT>         * {@link #writeRawData(DataOutput)} is called to write the type specific <a name="line.71"></a>
<FONT color="green">072</FONT>         * data.<a name="line.72"></a>
<FONT color="green">073</FONT>         */<a name="line.73"></a>
<FONT color="green">074</FONT>            public void write(String name, DataOutput out) throws IOException {<a name="line.74"></a>
<FONT color="green">075</FONT>                    writeStart(name, out);<a name="line.75"></a>
<FONT color="green">076</FONT>                    //write raw data<a name="line.76"></a>
<FONT color="green">077</FONT>                    writeRawData(out);<a name="line.77"></a>
<FONT color="green">078</FONT>            }<a name="line.78"></a>
<FONT color="green">079</FONT>        <a name="line.79"></a>
<FONT color="green">080</FONT>    }<a name="line.80"></a>




























































</PRE>
</BODY>
</HTML>
